
.486 
.model flat,stdcall 
option casemap:none 
 
include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\gdi32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\psapi.inc
    
;     libraries
;     ~~~~~~~~~
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib    
includelib \MASM32\LIB\ole32.lib

include Stack.asm
include UPN.asm
include Infix.asm



     
      DialogProc    PROTO :DWORD,:DWORD,:DWORD,:DWORD      
      Output proto:DWORD,:DWORD
      mycallback proto
      MAX_TERM equ 1024
      
      ID_TERM equ WM_USER+100
      ID_EINGABE equ WM_USER+101
      ID_PATH equ WM_USER+102
      IDC_INFIX equ WM_USER+103
      IDC_POSTFIX equ WM_USER+107
      IDC_INFO equ WM_USER+104
      ID_OUTPUT equ WM_USER+105
      ID_UPNTERM equ WM_USER+106
      
.data
 hInstance dd 0
 hBrush dd 0
 hWnd dd 0
 CRLF db 13,10,0
.data? 
 infixterm db(MAX_TERM) dup(?)
 postfixterm db (MAX_TERM*2) dup (?)    
 result REAL8 ?     
; 
.code
start:

     jmp @f       
        
        align dword 
        template DLGTEMPLATE < DS_MODALFRAME or DS_3DLOOK or DS_CENTER or WS_POPUP or \
                WS_CAPTION or WS_SYSMENU  or WS_VISIBLE or DS_SETFONT or WS_MINIMIZEBOX  , \
                0,6,0, 0, 150+13+13+11*3, 13+41+50>
       align 2
       dw 0,0,10,'M','S',' ','S','a','n','s',' ','S','e','r','i','f',0;'V','e','r','d','a','n','a',0        
       align 4
       
       DLGITEMTEMPLATE <WS_VISIBLE or WS_CHILD  ,0,1+11+150+2+11*3,1,11,11+11,IDC_INFO>
       align 2       
       dw 0ffffh,080h,0,0
        align 4
       
       DLGITEMTEMPLATE <WS_VISIBLE or WS_CHILD or BS_DEFPUSHBUTTON  ,0,1+11+150+2,1,11*3,11,IDC_INFIX>
       align 2       
       dw 0ffffh,080h,0,0
       
        align 4       
       DLGITEMTEMPLATE <WS_VISIBLE or WS_CHILD   ,0,1+11+150+2,1+11,11*3,11,IDC_POSTFIX>
       align 2       
       dw 0ffffh,080h,0,0
       
       align 4
        DLGITEMTEMPLATE <WS_VISIBLE or WS_CHILD or WS_BORDER or ES_AUTOHSCROLL,0,1,1,150+11,11,ID_TERM>
       align 2
         dw 0ffffh,081h,0,0   
        align 4
        DLGITEMTEMPLATE <WS_VISIBLE or WS_CHILD or WS_BORDER or ES_AUTOHSCROLL,0,1,12,150+11,11,ID_UPNTERM>
       align 2
         dw 0ffffh,081h,0,0   
       
         align 4
        DLGITEMTEMPLATE <WS_VISIBLE or WS_CHILD   or WS_BORDER or ES_AUTOHSCROLL or WS_VSCROLL \
                          or ES_MULTILINE or ES_AUTOVSCROLL or ES_READONLY,0,1,13+12,150+26+30,39+50-11,ID_OUTPUT>
       align 2
         dw 0ffffh,081h,0,0 
      
     
     
       Titel db "Infix-Taschenrechner",0  
       Button_text_infix db "Infix",0
       Button_text_postfix db "UPN",0
       Button_text_info db "?",0
       
       
      
        
       
      

 @@:      
      

     
      invoke GetModuleHandle,NULL
      mov hInstance,eax
      invoke DialogBoxIndirectParam,hInstance,addr template,NULL,addr DialogProc,NULL
      
      invoke ExitProcess,0

; 



DialogProc proc uses edi esi ebx ebp hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
LOCAL FilePath [MAX_PATH+1]:BYTE

    .if uMsg == WM_INITDIALOG
      
      push hWin
      pop hWnd
      
      
      invoke SetWindowText,hWin,addr Titel
      invoke GetDlgItem,hWin,IDC_INFIX
      invoke SetWindowText,eax,offset Button_text_infix
      invoke GetDlgItem,hWin,IDC_POSTFIX
      invoke SetWindowText,eax,offset Button_text_postfix
      
      invoke GetDlgItem,hWin,IDC_INFO
      invoke SetWindowText,eax,offset Button_text_info  
     
        
       
    .ELSEIF uMsg==WM_CTLCOLOREDIT

	INVOKE SetTextColor,wParam,09afafeh
		INVOKE SetBkColor,wParam,0555555h
		;invoke GetStockObject,BLACK_BRUSH	
		; set the background of the listbox
		Brush_check:
		mov eax, hBrush
		cmp eax, 0
		jne BrushAlreadyCreated
		invoke CreateSolidBrush,0555555h
		mov hBrush, eax
		BrushAlreadyCreated:

		mov eax, hBrush
		ret   
		
	 .elseif uMsg==WM_CTLCOLORSTATIC		 
	  
			invoke SetTextColor,wParam,0fed79ah

		    invoke SetBkColor,wParam,0555555h;0808080h
		    jmp Brush_check
		   ; invoke GetStockObject,GRAY_BRUSH
		    ret 	
    .elseif uMsg==WM_CTLCOLORDLG	 
	 
			invoke SetTextColor,wParam,Blue
		    invoke SetBkColor,wParam,Black
		    invoke GetStockObject,GRAY_BRUSH
		
		    ret      
    .elseif uMsg == WM_COMMAND    
        
     .if wParam == IDC_INFO
     	  .data
     	    Info_title db "About",0
     	    Info_text db "Autor: CDW",13,10,"www.cdw.de.vu",13,10,13,10
     	              db "Einfacher Infix-Taschenrechner in MASM",0   
     	    
     	    Error_not_allowed_term db "Zeichen nicht erlaubt: ",0   
     	    Error_stack_overflow db "Term zu gro - Stack overflow aufgetreten!",0
     	    Error_left_par db "Zu einer '(' existiert keine ')' Klammer!",0 
     	    Error_right_par db "Zu einer ')' existiert keine '(' : ",0       
     	    
     	    Error_not_allowed_dot db "Zahl hat zuviele Punkte: ",0
     	    Error_zero_div db 13,10,"Division durch 0 aufgetreten!",0
     	    Error_not_enough_operands db "Nicht genug Operanden!",0
     	    Error_not_enough_operators db "Nicht genug Operatoren!",0
     	    Error_unknown db "Unbekannter Fehler aufgetreten!",0
     

            	    
     	  .code
     	  invoke MessageBox,hWin,addr Info_text,addr Info_title,MB_ICONINFORMATION
     .elseif wParam==IDC_POSTFIX
          invoke GetDlgItemText,hWin,ID_UPNTERM,addr postfixterm,MAX_TERM
     	  test eax,eax ;Eingabe?
     	  je ENDE
     	  
     	  invoke Output,0,1 ;CLS Output
     	  invoke computeUPN,addr postfixterm,addr result,addr mycallback
     	  cmp eax,TRUE
     	  je OK2
     	    cmp eax,STACK_OVERFLOW
     	    je STACK_OVERFLOW_OUT
     	    
     	    cmp eax,ZERO_DIV
     	    jne @f
     	      invoke Output,addr Error_zero_div,0
     	      jmp ENDE
     	    @@:  
     	    cmp eax,NOT_ALLOWED_DOT
     	    jne @f
     	      invoke Output,addr Error_not_allowed_dot,0
     	      jmp ENDE
     	    @@:
     	    cmp eax,NOT_ENOUGH_OPERANDS 
     	    jne @f
     	      invoke Output,addr Error_not_enough_operands,0
     	      jmp ENDE
     	    cmp eax,NOT_ENOUGH_OPERATORS 
     	    jne @f
     	      invoke Output,addr Error_not_enough_operators,0     	   
     	      jmp ENDE
     	    @@:
     	      invoke Output,addr Error_unknown,0
     	      jmp ENDE    
     	  OK2:
     	  invoke FloatToStr2,result,addr postfixterm
     	  invoke Output,addr postfixterm,0
     	  
     .elseif wParam ==IDC_INFIX
          invoke GetDlgItemText,hWin,ID_TERM,addr infixterm,MAX_TERM
          test eax,eax ;Eingabe?
          je ENDE
          
     	  invoke Output,0,1
     	  invoke infixToUPN,addr infixterm,addr postfixterm
     	  cmp eax,TRUE
     	  je OK
     	    cmp eax,STACK_OVERFLOW
     	    jne @f     	      
     	      STACK_OVERFLOW_OUT:
     	      invoke Output, addr Error_stack_overflow,0
     	      jmp ENDE
     	    @@:
     	    cmp eax,LEFT_PARENTHESIS_ERROR
     	    jne @f     	      
     	      invoke Output, addr Error_left_par,0
     	      jmp ENDE
     	    @@:
     	    cmp eax,NOT_ALLOWED_TERMINAL
     	    jne @f
     	      invoke Output,addr Error_not_allowed_term,0
     	    @@:
     	    cmp eax,RIGHT_PARENTHESIS_ERROR
     	    jne @f
     	      invoke Output,addr Error_right_par,0
     	    @@:
     	    invoke Output,esi,0       	        
     	    jmp ENDE
     	  OK:
     	   invoke SetDlgItemText,hWin,ID_UPNTERM,addr postfixterm
     	   invoke SendMessage,hWin,WM_COMMAND,IDC_POSTFIX,0
     	  
     	  ENDE:
      .endif

    .elseif uMsg == WM_CLOSE     
      invoke EndDialog,hWin,0

    .endif

    xor eax, eax
    
    ret

DialogProc endp

Output proc out_:DWORD,flag:DWORD
   .data
      empty db 0
   .code
 	.if flag!=0
 	  invoke SetDlgItemText,hWnd,ID_OUTPUT,addr empty	
 	  ret
 	.endif
 	invoke SendDlgItemMessage,hWnd,ID_OUTPUT,EM_SETSEL,-1,-1
 	invoke SendDlgItemMessage,hWnd,ID_OUTPUT,EM_REPLACESEL,FALSE,out_ 	
 	ret

 Output endp
 
 mycallback proc

 LOCAL num1_string [32]:BYTE
 LOCAL num2_string [32]:BYTE
 LOCAL num1:QWORD
 LOCAL num2:QWORD
 	;in ST0,ST1 beide Zahlen
 	;in eax operator
 	 	
 	fstp qword ptr [num1]
 	cmp al,'='
 	je @f 	 ;bei = nur einen Operator ausgeben
 	  fst qword ptr [num2] 	
 	@@:
 	fld qword ptr [num1] ;widerherstellen
 	
 	movzx ebx,al
 	mov dword ptr[num2_string],ebx
 	invoke FloatToStr2,num1,addr num1_string
 	
 	cmp bl,'='
 	jne @f
 	  invoke Output,addr num2_string,0 
 	  invoke Output,addr num1_string,0 
 	  invoke Output, addr CRLF,0
 	  ret
 	@@: ;ansonsten: x+y
 			
 	invoke Output,addr num1_string,0 	;x
 	
 	invoke Output,addr num2_string,0 ;OP
 	invoke FloatToStr2,num2,addr num2_string
 	invoke Output,addr num2_string,0 ;y
 	 
 	
 	ret

 mycallback endp
end start